#!/bin/bash
#
# This really is a stupid shell script.
# But it's hopefully helpfull ..

VERSION="0.0.1"

    DIST=dist
    TARG=target
    LOCL=local
     SRC=src
    ROOT=root
     TMP=TMP

   LINUX="$DIST/linux"
 BUSYBOX="$DIST/busybox/busybox"
SYSLINUX="$DIST/syslinux/syslinux"
GENROMFS="$DIST/genromfs/genromfs"

    CONS="$ROOT/dev/@console,c,5,1"
  KERNEL="$LINUX/arch/i386/boot/bzImage"
  MODDIR="$LINUX/.tmp_versions"

: pause
pause()
{
cat <&3
echo ""
echo -n "Press return to continue, EOF (^D) to halt > "
read -ar a || exit 1
echo "OK"
echo ""
}

: check
check()
{
echo "checking for $2"
dir="`dirname "$1"`"
if [ ! -d "$dir" ]
then
	echo ""
	echo "Directory $dir is missing"
	echo "Perhaps softlink it to the $2 source directory!"
	echo "Grab $2 from $3"
	exit 1
fi
if [ ! -f "$1" ]
then
	echo ""
	echo "File $1 is missing"
	echo "Perhaps you have to compile everything."
	echo "Grab $2 from $3"
	exit 1
fi
}

pause 3<<EOF

Make HilbiX environment        VERSION $VERSION

HilbiX is a Linux based networked 1.44 MB rescue floppy.
(Currently only supports i386 platform.)

$CONTRIB/	There you might find some additional scripts.
$ROOT/		Contains the default initrd root scripts.

Note that you need bzip2 and mtools and the usual linux kernel
utilities to create the floppy image.

The next pages contain static iniformation.  Just hit return to skip
if you already know it.
EOF

pause 3<<EOF
You need following software accessible (perhaps use softlinks):

dist/linux/	The kernel, it should be as modularized as possible.
		Download 2.6.x from http://www.kernel.org/
		Preferably apply the latest kernel.org -mm patches.
		Create a maximum modularized kernel with
		make menuconfig
		perhaps see $SRC/linux*.config

dist/busybox/	The BusyBox for initial booting purpose.
		Grab it from CVS, see http://www.busybox.net/
		Create a minimum set of needed commands
		make menuconfig
		see $SRC/busybox.config and $SRC/busybox*.patch

dist/syslinux/	The syslinux distribution comes precompiled.
		Get it from http://syslinux.zytor.com/
		Perhaps read syslinux/distrib.doc

dist/genromfs/	The utility to prepare the initrd.
		Grab it from CVS, see http://romfs.sf.net/
		make
EOF

check "$KERNEL"   linux    "http://www.kernel.org/"
check "$BUSYBOX"  busybox  "http://www.busybox.net/"
check "$SYSLINUX" syslinux "http://syslinux.zytor.com/"
check "$GENROMFS" genromfs "http://romfs.sf.net/"

pause 3<<EOF

Configuration is done in following directories:

$TARG/		contains files like "TARGET".conf
		They are sourced in the initrd and must set variables
		like MODULES, NETDEV, IP, NETMASK, GATEWAY, SHELL
		Use src/sample.conf as an example.

$LOCL/		Place there what must go onto the initrd.
		Backup extensions are ignored.
		read README.local for more information

If you continue following will happen:

$TMP/		This directory is deleted and used for processing.

"TARGET".img	Will be overwritten with the floppy image containing
		your setup information.
EOF

#
# Everything is set up, run now
#

if [ -d "$TMP" ]
then
	echo "FATAL! Directory $TMP exists."
	echo "Please make sure it does not contain any valuable"
	echo "then remove it and restart this script again."
	exit 1
fi

if [ ! -f "$CONS" ]
then
	echo "FATAL! Console device not present as $CONS"
	echo "Something is broken with the distribution."
	echo "(For some reason you need a /dev/console in the initrd.)"
	exit 1
fi

: maxmtime
maxmtime()
{
find "$@" -type f -printf "%T@ %p\n" |
sort -rn |
(
read ign ref
echo "$ref"
cat >/dev/null	# suppress broken pipe
)
}

: copymod
copymod()
{
# Poor man's shell script stripper
### XXX FIXME ###
# This should process includes
# as it's annoying to copy'n'paste information
# if you have several disk images in one LAN.
awk '		{
		gsub(/^[[:space:]]/,"");
		gsub(/[[:space:]]$/,"");
		sub(/#[^'"'"'"]*$/,"");
		}
!/^#/ && ! /^$/	{ print }
' "$TARG/$1.conf" > "$2/hilbix.conf" &&

(
true
. "$2/hilbix.conf" || exit 1

{
for a in $DNS
do
	echo "nameserver $a"
done
} > "$2/etc/resolv.conf"

cat <<EOF >"$2/etc/host.conf"
order hosts, bind
multi on
EOF

cat <<EOF >"$2/etc/hosts"
127.0.0.1	localhost
$IP	$MACHINE
EOF

# Fix timestamps for freshly generated files
for a in "$2"/hilbix.conf "$2"/etc/*
do
	touch -r "$TARG/$1.conf" "$a" || exit 1
done

# Try to locate the module
### XXX FIXME XXX
# Missing dependency checking
for a in $MODULES
do
	if [ ! -f "$MODDIR/$a.mod" ]
	then
		echo ""
		echo "Module $a not found!"
		exit 1
	fi
	read mod < "$MODDIR/$a.mod"
	if [ ! -f "$LINUX/$mod" ]
	then
		echo ""
		echo "Module $a needs file $mod which does not exist!"
		exit 1
	fi
	ln "$LINUX/$mod" "$2/lib/$a.o" || exit 1
done
)
}

: copylocal
copylocal()
{
# The idea behind this is that you can override
# $ROOT and $LOCL
# with your own specific target files with a directory named
# $TARG/TARGET/
loc="$TARG/$1/"
[ ! -e "$loc" ] && loc=""
find "$ROOT/" "$LOCL/" $loc ! -type d ! -name '*~' ! -name '#*' ! -name '*#' ! -name '*.bak' -printf "%H %P\n" |
while read d f
do
	rm -f "$2/$f"
	p="`dirname "$2/$f"`"
	if [ ! -d "$p" ]
	then
		mkdir -p "$p" || return 1
	fi
	if [ -L "$d/$f" ]
	then
		cp -dp "$d/$f" "$2/$f" || return 1
	else
		rm -f "$2/$f"
		ln "$d/$f" "$2/$f" || return 1
		[ -e "$2/$f" ] || return 1
	fi
done
}

: prepinitrd
prepinitrd()
{
echo "$1: preparing initrd"

mkdir "$2" || return 1

for a in bin boot dev etc lib mnt proc sbin sys tmp usr
do
	mkdir "$2/$a" || return 1
done 

ln "$BUSYBOX" "$2/bin/" || return 1

for a in ash
do
	ln "$2/bin/busybox" "$2/bin/$a" || return 1
done

if	copymod "$1" "$2" &&
	copylocal "$1" "$2"
then
	ref="`maxmtime "$2"`"
	find "$2"     -type d -exec touch -r "$ref" "{}" \;
	find "$2/etc" -type f -exec touch -r "$ref" "{}" \;
else
	return 1
fi
}


: mkinitrd
mkinitrd()
{
echo "$1: creating initrd"

stamp="`find "$2" -printf "%T@" -prune`"

if	$GENROMFS -V "hilbix$stamp@`hostname`" -f "$TMP/initrd" -d "$2" &&
	touch -r "$2" "$TMP/initrd" &&
	gzip -9 "$TMP/initrd"
then
	echo "$1: initrd size = `wc -c < "$TMP/initrd.gz"`"
else
	return 1
fi
}

: prepimg
prepimg()
{
echo "$1: kernel size = `wc -c <"$KERNEL"`"
echo "$1: preparing floppy image"

echo "APPEND initrd=initrd.gz" > "$TMP/syslinux.cfg"
touch -r "$TMP/initrd.gz" "$TMP/syslinux.cfg"

export MTOOLSRC="$TMP/mtools.conf"
echo "drive a: file=\"$TMP/FLOPPY.img\" 1.44m mformat_only" > $MTOOLSRC

bzcat $SRC/empty.img.bz2 > "$TMP/FLOPPY.img"
}

: mkimg
mkimg()
{
echo "$1: creating floppy image"

if	$SYSLINUX "$TMP/FLOPPY.img" &&
	mcopy -mp "$KERNEL" a:/linux &&
	mcopy -mp "$TMP/syslinux.cfg" a:/ &&
	mcopy -mp "$TMP/initrd.gz" a:/
then
	free="`mdir a:/ | awk '/free/ { gsub(/[^0-9]/,""); printf "%7s", $1; }'`"
	echo "$1: floppy free = $free"
else
	return 1
fi
}

# Sad to say that syslinux does not set the modtime of ldlinux.sys to the real
# one.  However we know it is always the first entry in the main directory.
# So we can do a compare which ignores these known timestamp bytes.
: compareimage
compareimage()
{
cmp -l "$@" |
awk '
BEGIN	{
	ok[9743]=1
	ok[9744]=1
	ok[9751]=1
	ok[9752]=1
	ok[9753]=1
	ok[9754]=1
	}
ok[$1]	{ next }
	{ oops=1; exit(1); }
END	{ exit(oops); }'
}

: update
update()
{
if [ -e "$1.img" ]
then
	mv -f "$1.img" "$1.img.old" || return 1
fi
mv -f "$TMP/FLOPPY.img" "$1.img"
}

: process
process()
{
if	mkdir "$TMP" &&
	prepinitrd "$1" "$TMP/rom" &&
	mkinitrd "$1" "$TMP/rom" &&
	prepimg "$1" &&
	mkimg "$1"
then
	# I like to write tools which never touch
	# something which need not to be changed.
	if compareimage "$TMP/FLOPPY.img" "$1.img"
	then
		echo "$1.img unchanged"
	else
		echo "$1.img updated"
		if	update "$1"
		then
			unchanged=0
		else
			echo "!!! Sorry, target $1 failed !!!"
		fi
	fi
else
	echo "!!! Sorry, target $1 failed !!!"
fi

echo ""
#debug# ( mv "$TMP.oo" "$TMP.ooo"; mv "$TMP.o" "$TMP.oo"; mv "$TMP" "$TMP.o"; mv "$TMP.ooo" "$TMP"; ) 2>/dev/null
rm -rf "$TMP"
}

unchanged=2
if [ -n "$*" ]
then
	for a
	do
		process "$a"
	done
else
	for a in $TARG/*.conf
	do
		target="`basename "$a" .conf`"
		process "$target"
	done
fi

echo "done"
# return 0 if something has changed
# return 1 on error
# return 2 if nothing changed
exit $unchanged
